#version 330 core

in vec3 Position_viewspace;
in vec2 Texcoord;
in vec3 Color;

uniform sampler2D texture_diffuse;

uniform bool has_texture = true;

out vec4 out_color;

void main()
{
	vec3 object_color = Color;

	if (has_texture) {
		object_color = texture(texture_diffuse, Texcoord).rgb;
	}

	out_color = vec4(object_color, 1.0);

	if ( ! has_texture) {
		float fog = 1.0 - min(1.0, pow(length(Position_viewspace)/500.0, 0.5));
		out_color.rgb = mix(vec3(0.1), out_color.rgb, fog);
	}
}
