#version 330 core

layout(location = 0) in vec3 position;
layout(location = 3) in vec2 texcoord;
layout(location = 6) in vec3 color;

uniform mat4 projection;
uniform mat4 view;
uniform mat4 model;

out vec3 Position_viewspace;
out vec2 Texcoord;
out vec3 Color;

void main()
{
	Position_viewspace = vec3(view * model * vec4(position, 1.0));

	Texcoord = texcoord;
	Color = color;

	gl_Position = projection * view * model * vec4(position, 1.0);
}
